org.firstinspires.ftc.robotcore.external.matrices

## Class GeneralMatrixF

- java.lang.Object
- - org.firstinspires.ftc.robotcore.external.matrices.MatrixF
  - - org.firstinspires.ftc.robotcore.external.matrices.DenseMatrixF
    - - org.firstinspires.ftc.robotcore.external.matrices.RowMajorMatrixF
      - - org.firstinspires.ftc.robotcore.external.matrices.GeneralMatrixF

-     public class GeneralMatrixF
      extends RowMajorMatrixF

  A `GeneralMatrixF` is a concrete matrix implementation that is supported by a backing store consisting of an array of floats. The matrix is stored in row-major order.

- - ### Field Summary

    - ### Fields inherited from class org.firstinspires.ftc.robotcore.external.matrices.MatrixF

      `numCols, numRows`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `GeneralMatrixF(int numRows, int numCols)`
    `GeneralMatrixF(int numRows, int numCols, float[] data)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `MatrixF` | `emptyMatrix(int numRows, int numCols)` Returns a new empty matrix of the indicated dimensions.
    `float[]` | `getData()` Returns the contiguous array of floats which is the storage for this matrix
    `GeneralMatrixF` | `transposed()` Returns a matrix which is the transposition of the receiver matrix.

    - ### Methods inherited from class org.firstinspires.ftc.robotcore.external.matrices.RowMajorMatrixF

      `indexFromRowCol, toVector`

    - ### Methods inherited from class org.firstinspires.ftc.robotcore.external.matrices.DenseMatrixF

      `get, put`

    - ### Methods inherited from class org.firstinspires.ftc.robotcore.external.matrices.MatrixF

      `adaptHomogeneous, add, add, add, added, added, added, diagonalMatrix, diagonalMatrix, dimensionsError, dimensionsError, formatAsTransform, formatAsTransform, getColumn, getRow, getTranslation, identityMatrix, inverted, multiplied, multiplied, multiplied, multiplied, multiply, multiply, multiply, multiply, numCols, numRows, slice, slice, subtract, subtract, subtract, subtracted, subtracted, subtracted, toString, transform`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### GeneralMatrixF

          public GeneralMatrixF(int numRows,
                                int numCols)

    - #### GeneralMatrixF

          public GeneralMatrixF(int numRows,
                                int numCols,
                                float[] data)

  - ### Method Detail

    - #### getData

          public float[] getData()

      Description copied from class: `DenseMatrixF`
      Returns the contiguous array of floats which is the storage for this matrix
      Specified by:
        `getData` in class `DenseMatrixF`
      Returns:
        the contiguous array of floats which is the storage for this matrix

    - #### emptyMatrix

          public MatrixF emptyMatrix(int numRows,
                                     int numCols)

      Description copied from class: `MatrixF`
      Returns a new empty matrix of the indicated dimensions. If a specific implementation associated with the receiver can be used with these dimensions, then such is used; otherwise a general matrix implementation will be used.
      Specified by:
        `emptyMatrix` in class `MatrixF`
      Returns:
        a new empty matrix of the indicated dimensions
      See Also:
        `OpenGLMatrix.emptyMatrix(int, int)`

    - #### transposed

          public GeneralMatrixF transposed()

      Description copied from class: `MatrixF`
      Returns a matrix which is the transposition of the receiver matrix.
      Overrides:
        `transposed` in class `MatrixF`
      Returns:
        a matrix which is the transposition of the receiver matrix.